#include<bits/stdc++.h>
using namespace std;
long long n;
int kolkoihima[20];
int a[1000005];
int br,poz,k,mx,pozzadnjeg;
bool prov;
int main()
{
    cin>>n;
    k=1;
    for(int i=1;i<=n;i++)
    {
        cin>>a[i];
        kolkoihima[a[i]]++;
    }
    if(n==2)
    {
        swap(a[1],a[2]);
        for(int i=1;i<=n;i++)
        {
            cout<<a[i]<<" ";
        }
        cout<<endl;
        return 0;
    }
    mx=a[1];
    for(int i=1;i<=n;i++)
    {
        if(a[i]<a[i+1])
        {
            poz=i+1;
            mx=a[i+1];
            prov=true;
            break;
        }
    }
    if(prov)
    {
        for(int i=poz;i<=n;i++)
        {
            if(a[i]>=mx)
            {
                mx=a[i];
                pozzadnjeg=i;
            }
        }
    }
    if(prov)
    {
        while(a[k]>=mx)
        {
            k++;
        }
        swap(a[k],a[pozzadnjeg]);
        for(int i=1;i<=n;i++)
        {
            cout<<a[i]<<" ";
        }
        cout<<endl;
        return 0;
    }
    else
    {
        for(int i=1;i<=10;i++)
        {
            if(kolkoihima[i]>1)
            {
                for(int j=1;j<=n;j++)
                {
                    cout<<a[j]<<" ";
                }
                cout<<endl;
                return 0;
            }
        }
        swap(a[n],a[n-1]);
        for(int i=1;i<=n;i++)
        {
            cout<<a[i]<<" ";
        }
        cout<<endl;
        return 0;
    }
    return 0;
}